commit 8fdbbec22de1bdb8f7cc60c13798050edcafe696
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Mon Jan 26 10:52:12 2026 +0000

        Taint: track the dns answer buffers as being tainted

diff --git a/src/src/dns.c b/src/src/dns.c
index 6b527ef00..15f4c8cd0 100644
--- a/src/src/dns.c
+++ b/src/src/dns.c
@@ -376,7 +376,6 @@ if (reset != RESET_NEXT)
   while (dnss->rrcount-- > 0)
     {
     TRACE trace = "Q-namelen";
-    /*TTT*/
     if ((namelen = dns_rr_expand_taint(dnsa->answer, eom, dnss->aptr, dnss)) <0)
       goto null_return;
     /* skip name & type & class */
@@ -407,7 +406,6 @@ if (reset != RESET_NEXT)
     while (dnss->rrcount-- > 0)
       {
       TRACE trace = "A-namelen";
-      /*TTT*/
       if (  (namelen = dns_rr_expand_taint(dnsa->answer, eom, dnss->aptr, dnss))
 	  < 0)
 	goto null_return;
@@ -442,7 +440,6 @@ if (dnss->rrcount-- <= 0) return NULL;
 (something safe). */
 
 TRACE trace = "R-namelen";
-/*TTT*/
 if ((namelen = dns_rr_expand_taint(dnsa->answer, eom, dnss->aptr, dnss)) < 0)
   goto null_return;
 
@@ -507,7 +504,7 @@ if (h->nscount && h->aa)
   for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_AUTHORITY);
        rr; rr = dns_next_rr(dnsa, &dnss, RESET_NEXT))
     if (rr->type == (h->ancount ? T_NS : T_SOA))
-      return string_copy(rr->name);	/*TTT*/
+      return string_copy(rr->name);
 return NULL;
 }
 
@@ -1061,7 +1058,7 @@ former will work. */
 for (int i = 0; i <= dns_cname_loops; i++)
   {
   uschar * data;
-  dns_record cname_rr, type_rr;
+  dns_record cname_rr = {0}, type_rr = {0};
   dns_scan dnss = {0};
 
   /* DNS lookup failures get passed straight back. */
@@ -1075,7 +1072,6 @@ for (int i = 0; i <= dns_cname_loops; i++)
   contents of any rr blocks returned by dns_next_rr() as they use the same
   area in the dnsa block. */
 
-  cname_rr.data = type_rr.data = NULL;
   for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS);
        rr; rr = dns_next_rr(dnsa, &dnss, RESET_NEXT))
     if (rr->type == type)
@@ -1103,7 +1099,7 @@ for (int i = 0; i <= dns_cname_loops; i++)
 	  )
 #endif
        )
-        *fully_qualified_name = string_copy_dnsdomain(rr_name);	/*TTT*/
+        *fully_qualified_name = string_copy_dnsdomain(rr_name);
     }
 
   /* If any data records of the correct type were found, we are done. */
@@ -1127,7 +1123,7 @@ for (int i = 0; i <= dns_cname_loops; i++)
     }
 
   /* DNS data comes from the outside, hence tainted */
-  data = store_get(256, GET_TAINTED);				/*TTT alloc*/
+  data = store_get(256, GET_TAINTED);
   if (dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen,
       cname_rr.data, (DN_EXPAND_ARG4_TYPE)data, 256) < 0)
     {
@@ -1359,7 +1355,7 @@ switch (type)
 	/* If it's making an interesting assertion, return this response. */
 	if (port & 1)
 	  {
-	  *fully_qualified_name = namesuff + 1;	/*TTT*/
+	  *fully_qualified_name = namesuff + 1;
 	  return DNS_SUCCEED;
 	  }
 	}
diff --git a/src/src/dnsbl.c b/src/src/dnsbl.c
index 8a3d02184..e12a120fa 100644
--- a/src/src/dnsbl.c
+++ b/src/src/dnsbl.c
@@ -364,8 +364,7 @@ if (cb->rc == DNS_SUCCEED)
 	  int len = (rr->data)[0];
 	  if (len > 511) len = 127;
 	  store_pool = POOL_PERM;
-	  /*TTT*/
-	  cb->text = string_copyn_taint(CUS (rr->data+1), len, GET_TAINTED);
+	  cb->text = string_copyn(CUS (rr->data+1), len);
 	  store_pool = old_pool;
 	  break;
 	  }
diff --git a/src/src/functions.h b/src/src/functions.h
index 27d1d2504..c95ea2dc4 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -1138,26 +1138,14 @@ return item
 /* Use store_malloc for DNSA structs, and explicit frees. Using the same pool
 for them as the strings we proceed to copy from them meant they could not be
 released, hence blowing 64k for every DNS lookup. That mounted up. With malloc
-we do have to take care over marking tainted all copied strings.
-A separate pool could be used and could handle taint implicitly - but we would
-want to support independent free ops, not limited to stacked alloc/release */
+we do have to special-case taint checking (see store.c). */
 
+extern dns_answer * store_get_dns_answer_trc(const uschar *, unsigned);
 #define store_get_dns_answer() store_get_dns_answer_trc(CUS __FUNCTION__, __LINE__)
 
-static inline dns_answer *
-store_get_dns_answer_trc(const uschar * func, unsigned line)
-{
-return store_malloc_3(sizeof(dns_answer), CCS func, line);
-}
-
+extern void store_free_dns_answer_trc(dns_answer *, const uschar *, unsigned);
 #define store_free_dns_answer(dnsa) store_free_dns_answer_trc(dnsa, CUS __FUNCTION__, __LINE__)
 
-static inline void
-store_free_dns_answer_trc(dns_answer * dnsa, const uschar * func, unsigned line)
-{
-store_free_3(dnsa, CCS func, line);
-}
-
 
 /* Check for an RR being large enough.  Return TRUE iff bad. */
 static inline BOOL
diff --git a/src/src/host.c b/src/src/host.c
index 1bafda996..c4ca666cf 100644
--- a/src/src/host.c
+++ b/src/src/host.c
@@ -1667,7 +1667,6 @@ while ((ordername = string_nextinlist(&list, &sep, NULL, 0)))
         /* If an overlong response was received, the data will have been
         truncated and dn_expand may fail. */
 
-	/*TTT*/
         if (dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen,
              US rr->data, (DN_EXPAND_ARG4_TYPE)(s), ssize) < 0)
           {
@@ -2395,7 +2394,7 @@ for (; i >= 0; i--)
       if (thishostlast == NULL)
 	{
 	if (strcmpic(host->name, rr->name) != 0)
-	  host->name = string_copy_dnsdomain(rr->name);	/*TTT*/
+	  host->name = string_copy_dnsdomain(rr->name);
 	host->address = da->address;
 	host->sort_key = host->mx * 1000 + random_number(500) + randoffset;
 	host->status = hstatus_unknown;
@@ -2789,7 +2788,10 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS);
   int port = PORT_NONE;		/* MX lookups get PORT_NONE */
   const uschar * s = rr->data;	/* MUST be unsigned for GETSHORT */
   host_item * next;
-  uschar data[256];	/*TTT*/
+
+  /* Properly, should be tainted. string_copy_dnsdomain() call below must be
+  the only outside use if data placed here by dn_expand(). */
+  uschar data[256];
 
   if (rr_bad_size(rr, sizeof(uint16_t))) continue;
   GETSHORT(precedence, s);      /* Pointer s is advanced */
@@ -2816,7 +2818,6 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS);
 
   /* Get the name of the host pointed to. */
 
-  /*TTT*/
   if (dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, s,
       (DN_EXPAND_ARG4_TYPE)data, sizeof(data)) < 0)
     continue;
@@ -2858,7 +2859,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS);
   before the first block, copy the first block's data to a new second block. */
 
   next = last ? store_get(sizeof(host_item), GET_UNTAINTED) : host;
-  next->name = string_copy_dnsdomain(data);	/*TTT*/
+  next->name = string_copy_dnsdomain(data);
   next->address = NULL;
   next->port = port;
   next->mx = precedence;
diff --git a/src/src/lookups/dnsdb.c b/src/src/lookups/dnsdb.c
index 80cf2e62a..a17264501 100644
--- a/src/src/lookups/dnsdb.c
+++ b/src/src/lookups/dnsdb.c
@@ -140,13 +140,13 @@ int sep = 0, rc, type, failrc = FAIL;
 const uschar * outsep = CUS"\n", * outsep2 = NULL;
 uschar * equals, * domain, * found;
 
-dns_answer * dnsa = store_get_dns_answer();	/*TTT alloc */
+dns_answer * dnsa = store_get_dns_answer();
 dns_scan dnss = {0};
 
 /* Because we're working in the search pool, we try to reclaim as much
 store as possible later, so we preallocate the result here */
 
-gstring * yield = string_get_tainted(256, GET_TAINTED);	/*TTT alloc*/
+gstring * yield = string_get_tainted(256, GET_TAINTED);
 
 /* If the string starts with '>' we change the output separator.
 If it's followed by ';' or ',' we set the TXT output separator. */
@@ -403,7 +403,6 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 	  remain = rr->size - ++data_offset;
 	  if (chunk_len > remain)
 	    chunk_len = remain;
-	  /*TTT*/
 	  yield = string_catn(yield, US ((rr->data) + data_offset), chunk_len);
 	  data_offset += chunk_len;
 
@@ -428,7 +427,6 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 
 	  if (payload_length > MAX_TLSA_EXPANDED_SIZE)
 	    payload_length = MAX_TLSA_EXPANDED_SIZE;
-	  /*TTT*/
 	  yield = string_fmt_append(yield, "%d%c%d%c%d%c%.*H",
 				      usage, *outsep2,
 				      selector, *outsep2,
@@ -442,8 +440,7 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 
 	/* NB: this memory is released implicitly by the call
 	gstring_release_unused(yield) below. We used to use a stack-auto, but
-	I want to track taint wherever possible. The dnsa is not (yet)
-	allocated using taint-marked memory. */
+	I want to track taint wherever possible. */
 #define LCL_BUF_SIZE 264
 	uschar * buf = store_get(LCL_BUF_SIZE, GET_TAINTED);
 
@@ -504,7 +501,6 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 
         /* GETSHORT() has advanced the pointer to the target domain. */
 
-	/*TTT*/
         rc = dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, p,
           (DN_EXPAND_ARG4_TYPE)buf, LCL_BUF_SIZE);
 
@@ -526,7 +522,6 @@ while ((domain = string_nextinlist(&keystring, &sep, NULL, 0)))
 	  p += rc;
 	  yield = string_catn(yield, outsep2, 1);
 
-	  /*TTT*/
 	  rc = dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, p,
 	    (DN_EXPAND_ARG4_TYPE)buf, LCL_BUF_SIZE);
 	  if (rc < 0)
diff --git a/src/src/miscmods/dkim.c b/src/src/miscmods/dkim.c
index 4bd87bbf9..d6858a00c 100644
--- a/src/src/miscmods/dkim.c
+++ b/src/src/miscmods/dkim.c
@@ -83,7 +83,7 @@ dkim_exim_query_dns_txt(const uschar * name)
 dns_answer * dnsa = store_get_dns_answer();
 dns_scan dnss = {0};
 rmark reset_point = store_mark();
-gstring * g = string_get_tainted(256, GET_TAINTED);	/*TTT alloc*/
+gstring * g = string_get_tainted(256, GET_TAINTED);
 
 lookup_dnssec_authenticated = NULL;
 if (dns_lookup(dnsa, name, T_TXT, NULL) != DNS_SUCCEED)
@@ -100,7 +100,6 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS);
       {
       uschar len = rr->data[rr_offset++];
 
-      /*TTT*/
       g = string_catn(g, US(rr->data + rr_offset), len);
       if (g->ptr >= PDKIM_DNS_TXT_MAX_RECLEN)
 	goto bad;
diff --git a/src/src/miscmods/spf.c b/src/src/miscmods/spf.c
index a0cdb8dc6..bc4131071 100644
--- a/src/src/miscmods/spf.c
+++ b/src/src/miscmods/spf.c
@@ -140,8 +140,7 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
 	the lib assumes it can free this (it does for srr.rr) - meaning we
 	cannot use pool store. The use of malloc also for T_TXT implies so. */
 
-	uschar * buf = store_malloc(256);	/*TTT alloc*/
-	/*TTT*/
+	uschar * buf = store_malloc(256);
 	if (dn_expand(dnsa->answer, dnsa->answer + dnsa->answerlen, s,
 	    (DN_EXPAND_ARG4_TYPE)buf, 256) < 0)
 	  continue;
@@ -168,11 +167,12 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
 	  if (  !(chunk_len = s[offset++])
 	     || rr->size < offset + chunk_len	/* ignore bogus size chunks */
 	     ) break;
-	  g = string_catn(g, s+offset , chunk_len);	/*TTT*/
+	  g = string_catn(g, s+offset , chunk_len);
 	  }
 	if (!g)
 	  continue;
-	s = string_copy_malloc(string_from_gstring(g));	/*TTT*/
+	/* Again, we lose taint-tracking here */
+	s = string_copy_malloc(string_from_gstring(g));
 	gstring_reset(g);
 	gstring_release_unused(g);
 	DEBUG(D_receive) debug_printf_indent("SPF_dns_exim_lookup '%s'\n", s);
@@ -183,7 +183,8 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
       case T_AAAA:
       default:
 	{
-	uschar * buf = store_malloc(dnsa->answerlen + 1);	/*TTT alloc*/
+	uschar * buf = store_malloc(dnsa->answerlen + 1);
+	/* Again, we lose taint-tracking here */
 	s = memcpy(buf, s, dnsa->answerlen + 1);
 	break;
 	}
diff --git a/src/src/store.c b/src/src/store.c
index e265acd4c..6478dc3e7 100644
--- a/src/src/store.c
+++ b/src/src/store.c
@@ -210,12 +210,17 @@ static const uschar * poolclass[N_PAIRED_POOLS] = {
 [POOL_TAINT_SEARCH] =	US"tainted",
 [POOL_TAINT_MESSAGE] =	US"tainted",
 };
+
+
+static dns_answer * dnsa_tainted = NULL;
+
 #endif
 
 
 static void * internal_store_malloc(size_t, const char *, int);
 static void   internal_store_free(void *, const char *, int linenumber);
 
+
 /******************************************************************************/
 
 static void
@@ -285,6 +290,17 @@ log_write_die(0, LOG_MAIN,
 return NULL;
 }
 
+
+/******************************************************************************/
+static BOOL
+is_tainted_dnsa(const void * p)
+{
+#ifndef COMPILE_UTILITY
+for (dns_answer * dnsa = dnsa_tainted; dnsa; dnsa = dnsa->next)
+  if (CS p >= CS dnsa && CS p < CS(dnsa+1)) return TRUE;
+#endif
+return FALSE;
+}
 /******************************************************************************/
 /* Test if a pointer refers to tainted memory.
 
@@ -321,7 +337,7 @@ for (quoted_pooldesc * qp = quoted_pools; qp; qp = qp->next)
   for (b = qp->pool.chainbase; b; b = b->next)
     if (is_pointer_in_block(b, p)) return TRUE;
 
-return FALSE;
+return is_tainted_dnsa(p);
 }
 
 
@@ -1258,6 +1274,29 @@ n_nonpool_blocks--;
 internal_store_free(block, func, linenumber);
 }
 
+/******************************************************************************/
+#ifndef COMPILE_UTILITY
+/* Block-handling for dns answers - a bit over 64k each.
+We maintain a list for taint-tracking; these are from the outside so always
+tainted. Expect less than 3, so a linked-list is fine. */
+
+dns_answer *
+store_get_dns_answer_trc(const uschar * func, unsigned line)
+{
+dns_answer * dnsa = store_malloc_3(sizeof(dns_answer), CCS func, line);
+dnsa->next = dnsa_tainted;
+return dnsa_tainted = dnsa;
+}
+
+void
+store_free_dns_answer_trc(dns_answer * dnsa, const uschar * func, unsigned line)
+{
+for (dns_answer ** dp = &dnsa_tainted; *dp; dp = &((*dp)->next))
+  if (*dp == dnsa) { *dp = (*dp)->next; break; }
+store_free_3(dnsa, CCS func, line);
+}
+#endif	/*COMPILE_UTILITY*/
+
 /******************************************************************************/
 /* Stats output on process exit */
 void
diff --git a/src/src/string.c b/src/src/string.c
index b37606cf3..5e66e0732 100644
--- a/src/src/string.c
+++ b/src/src/string.c
@@ -613,6 +613,8 @@ allow_utf8_domains is set true and UTF-8 characters are used in domain
 names. Backslash can also be used to escape other characters, though we
 shouldn't come across them in domain names.
 
+We always return tainted mem, as some callers use stack-auto source buffers.
+
 Argument:   the domain name string
 Returns:    copy of string in new store, de-escaped
 */
@@ -621,7 +623,6 @@ uschar *
 string_copy_dnsdomain(const uschar * s)
 {
 uschar * yield;
-/*TTT*/
 uschar * ss = yield = store_get(Ustrlen(s) + 1, GET_TAINTED);	/* always treat as tainted */
 
 while (*s)
diff --git a/src/src/structs.h b/src/src/structs.h
index 52b540356..20438bb47 100644
--- a/src/src/structs.h
+++ b/src/src/structs.h
@@ -770,7 +770,8 @@ typedef struct {
 /* Structure for holding the result of a DNS query.  A touch over
 64k big, so take care to release as soon as possible. */
 
-typedef struct {
+typedef struct dns_answer {
+  struct dns_answer * next;
   int     answerlen;              /* length of the answer */
   uschar  answer[NS_MAXMSG];      /* the answer itself */
 } dns_answer;
diff --git a/src/src/tls-gnu.c b/src/src/tls-gnu.c
index 1610387d9..17ee21ef0 100644
--- a/src/src/tls-gnu.c
+++ b/src/src/tls-gnu.c
@@ -3416,7 +3416,10 @@ for (dns_record * rr = dns_next_rr(dnsa, &dnss, RESET_ANSWERS); rr;
     ) if (rr->type == T_TLSA && rr->size > 3)
   {
   const uschar * p = rr->data;
-/*XXX need somehow to mark rr and its data as tainted.  Doues this mean copying it? *//*TTT*/
+/*XXX need somehow to mark rr and its data as tainted.
+Doues this mean copying it?  That could actually be preferable, as the 64k
+of dns_annwer could be alloc/free within this func. */
+/*TTT*/
   uint8_t usage = p[0], sel = p[1], type = p[2];
 
   DEBUG(D_tls)

